#! /bin/sh
#-------------------------------------------------------------
#procedure to send everyone who are over $PERCENTMAX % of their quota. Default at 90%.
#-------------------------------------------------------------
#local variable
#originator filed max length
MAXORIG=30
MAXSUBJ=50
PERCENTMAX=90
#Default prfid is 2.
prfid=2
#-------------------------------------------------------------
#setting the basic definition
. `dirname $0`/../shell/version.sh

#-------------------------------------------------------------
#loading the variable value
. $BASE/etc/sysconfig/$APPNAME
clmsndr="$BASE/usr/bin/clmsndr"
Error='0'
LoggerApp="logger -t clmsndr"


#setting the Variable
#first the Data-base type
if [ -z "$DB_TYPE" ] ; then
  DB_TYPE=POSTGRESQL;
  fi

#Then the data-base name
if [ -z "$DB_NAME" ] ; then
  DB_NAME=$APPNAME;
  fi

#-------------------------------------------------------------
case "$DB_TYPE" in
  "POSTGRESQL"  )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-p $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  "MYSQL"       )
     if [ ! -z "$DB_PORT" ] ; then
       SQLPORT="-P $DB_PORT"
       fi
     if [ ! -z "$DB_HOST" ] ; then
       SQLHOST="-h $DB_HOST"
       fi
     ;;
  esac

#----------------------------------------------
#procedure to probe data-base qith an SQL request
#as $1 parametere
prob_db()

{
case "$DB_TYPE" in
  "POSTGRESQL"  )
     echo "$1" | psql -t -q  -A -F ' ' $SQLPORT $SQLHOST $DB_NAME
     ;;
  "MYSQL"       )
     echo "$1" | mysql -s -u $APPNAME $SQLPORT $SQLHOST $DB_NAME
     ;;
  esac
}

#---------------------------------------------------------
#Check the user prfid in order to determine it language.
langCheck()
{
#$1 username
prfid=`prob_db "SELECT prfid FROM users WHERE username='$1';"`
lang=`prob_db "SELECT lang FROM userprofile WHERE prfid='$prfid';"`
case "$lang" in
  2	)
    . $BASE/etc/$APPNAME-$VERS/report_francais.conf
    ;;
  1	|							\
  *	)
	. $BASE/etc/$APPNAME-$VERS/report_english.conf
    ;;
  esac
}
#transmet
#print mail to be send to one user.
#$1 'to' clement recipient

#----------------------------------------------


transmet ()

{
cat | $clmsndr $1

RETVAL=$?
Error=1
        whoError="while trying to mail $username for QUOTA (Status $RETVAL)(clement sender)"
        case "$RETVAL" in
        0)
       		Error=0
	 ;;
        1)
                $LoggerApp "Unable to get local email $whoError"
        ;;
        2)
                $LoggerApp "Unable to contact remote server $whoError"
        ;;
        3)
                $LoggerApp "Originator is not accepted by remote $whoError"
        ;;
        4)
                $LoggerApp "One recipient is not Accepted $whoError"
        ;;
        5)
                $LoggerApp "Remote do not accept data $whoError"
        ;;
        6)
                $LoggerApp "Unassigned $whoError"
        ;;
        7)
                $LoggerApp "Email is not accepted by remote $whoError"
        ;;
        *)
                $LoggerApp "Unknown error in clmsndr $whoError"
        ;;
        esac
        numMail='0'

return $Error
}
#----------------------------------------------
print_mail_header ()
#$1 user
{
        echo "From: $senderQuota <"`id -un`@`uname -n | cut -d'.' -f2-`">" 
        echo "To: "$1
        echo "Reply-To: Noreply@`uname -n | cut -d'.' -f2-`"
        echo "$subjectQuota (`LANG=$formatLang date +\"%a, %b %d %H:%M:%S \"`)"
        echo "Date: `date -R`"
}
#----------------------------------------------
print_header ()
#$1 recipient name
{
realname=`prob_db "SELECT realname FROM users WHERE username='$1';"`
echo "$salutation $realname,"
echo ""
echo "$headerQuota"
echo ""
}


#----------------------------------------------
print_core ()

{
echo "$bodyQuota"
}

#----------------------------------------------
print_email ()

{
#$1 user
langCheck $1
(
print_mail_header $1 
#header separator
echo ""			
print_header $1
print_core
#print_footer
) | transmet $1
return $?
}

#----------------------------------------------
profileMax=`prob_db "SELECT mxmgbytes FROM userprofile WHERE prfid=$prfid;"`
all_users=`prob_db 						\
		"SELECT DISTINCT username FROM users 		\
			WHERE prfid=$prfid AND 			\
			usedmgbytes>$profileMax*$PERCENTMAX/100	\
			 ORDER BY username;"`

if [ -x $clmsndr ]; then
  (
  for user in $all_users
    do
    print_email $user
    Error=$?
    if [ $Error = '1' ]; then
      break
    fi
    done
  )
else
  $LoggerApp "Error: Clement sender do not exist or is not accessible!!!"
fi

