#! /bin/sh -xv
#---------------------------------------------------------------
#procedure to update site data-base according upgrade version
#---------------------------------------------------------------
#Only one (optionnal) argument
#$1 base	;the testing base.
#---------------------------------------------------------------
#presetting previous version release
REL=0			
#setting the basic definition
if [ -f `dirname $0`/../shell/prev-version.sh ] ; then
  . `dirname $0`/../shell/prev-version.sh
else 
  #setting RELNUM for clement-2.1
  RELNUM=21343
  fi
export OLDVERS=$VERSION.$LEVEL-$SUBLEV.$RELEASE
export PRVRELNUM=$RELNUM
#---------------------------------------------------------------
#loading the variable value
. `dirname $0`/../../../../etc/sysconfig/$APPNAME
. `dirname $0`/../shell/version.sh
export CURVERS=$VERSION.$LEVEL-$SUBLEV.$RELEASE
#---------------------------------------------------------------
#setting log file
LOGFILE=$BASE/etc/clement-$VERS/dbinst.log
UTIL=`dirname $0`/../utilitities
#setting SQL
SQL="/usr/bin/psql -q -t"
#---------------------------------------------------------------
#procedure to upgrade from clement-2.1
#---------------------------------------------------------------
from_210xxx()

{
echo "Warning! Conversion need to be done manually (see README)"
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-60
#---------------------------------------------------------------
upto_25060()

{
echo "Upgrading data-base to version $VERS-60" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE clmgroup ADD COLUMN mxmgbytes INTEGER;"
echo "ALTER TABLE clmgroup ALTER COLUMN mxmgbytes SET DEFAULT 100*1024;"
echo "UPDATE clmgroup SET mxmgbytes=100*1024;"
echo "ALTER TABLE userprofile ADD COLUMN mxmgbytes INTEGER;"
echo "ALTER TABLE userprofile ALTER COLUMN mxmgbytes SET DEFAULT 10*1024;"
echo "UPDATE userprofile SET mxmgbytes=0 WHERE profname = 'foreign';"
echo "UPDATE userprofile SET mxmgbytes=10*1024 WHERE profname != 'foreign';"
echo "ALTER TABLE users ADD COLUMN usedmgbytes INTEGER;"
echo "ALTER TABLE users ALTER COLUMN usedmgbytes SET DEFAULT 0;"
echo "UPDATE users SET usedmgbytes=0;"
echo "ALTER TABLE domain ADD COLUMN usedmgbytes INTEGER;"
echo "ALTER TABLE domain ALTER COLUMN usedmgbytes SET DEFAULT 0;"
echo "UPDATE domain SET usedmgbytes=0;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-62
#---------------------------------------------------------------
upto_25062()

{
echo "Upgrading data-base to version $VERS-62" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE userprofile ADD COLUMN backdays INTEGER;"
echo "ALTER TABLE userprofile ALTER COLUMN backdays SET DEFAULT 365;"
echo "UPDATE userprofile SET backdays=0 WHERE profname = 'foreign';"
echo "UPDATE userprofile SET backdays=365 WHERE profname != 'foreign';"
echo "UPDATE userprofile SET backdays=180 WHERE profname = 'system';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}

#---------------------------------------------------------------
#procedure to upgrade to 2.5-65
#---------------------------------------------------------------
upto_25065()

{
echo "Upgrading data-base to version $VERS-65" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE users ALTER COLUMN prfid SET DEFAULT 2;"
echo "UPDATE users SET prfid=2;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-68
#---------------------------------------------------------------
upto_25068()

{
echo "Upgrading data-base to version $VERS-68" >> $LOGFILE
#Updating data-base structure
(
echo "CREATE TABLE intusers  ("
echo "username TEXT UNIQUE NOT NULL,"
echo "status INTEGER,"
echo "stamp TIMESTAMP WITH TIME ZONE DEFAULT NOW()"
echo ");"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-70
#---------------------------------------------------------------
upto_25070()

{
echo "Upgrading data-base to version $VERS-70" >> $LOGFILE
#Updating data-base structure
(
echo "CREATE TABLE inqueue  ("
echo "session TEXT,"
echo "transit INTEGER,"
echo "outip TEXT,"
echo "smtpmx TEXT,"
echo "smtpport INTEGER,"
echo "orgeml TEXT,"
echo "recname TEXT,"
echo "recdom TEXT,"
echo "subject TEXT,"
echo "start TIMESTAMP WITH TIME ZONE DEFAULT NOW(),"
echo "next TIMESTAMP WITH TIME ZONE,"
echo "last TIMESTAMP WITH TIME ZONE,"
echo "upto TIMESTAMP WITH TIME ZONE,"
echo "mode INTEGER DEFAULT 0,"
echo "retry INTEGER DEFAULT 0,"
echo "progress INTEGER DEFAULT 1,"
echo "status INTEGER DEFAULT 0,"
echo "why TEXT DEFAULT NULL"
echo ");"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-72
#---------------------------------------------------------------
upto_25072()

{
echo "Upgrading data-base to version $VERS-72" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE autoreply ADD nomessage INTEGER default 0;"
) | tee -a $LOGFILE | $SQL $DB_NAME
(
echo "CREATE TABLE domainalias ("
echo "ALIAS TEXT UNIQUE NOT NULL,"
echo "domainname TEXT);"
) | tee -a $LOGFILE | $SQL $DB_NAME
(
echo "INSERT INTO domainalias (alias,domainname) VALUES ('$(hostname)','$(dnsdomainname)');"
echo "INSERT INTO domainalias (alias,domainname) VALUES ('localhost.localdomain','$(dnsdomainname)');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-74
#---------------------------------------------------------------
upto_25074()

{
echo "Upgrading data-base to version $VERS-74" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE domain ADD mxmgbytes INTEGER default 10*1024;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-82
#---------------------------------------------------------------
upto_25082()

{
echo "Upgrading data-base to version $VERS-82" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE filterinfo ADD bgcolor text;"
echo "UPDATE filterinfo set bgcolor='#c7fbf5' where color='turquoise';"
echo "UPDATE filterinfo set bgcolor='#bbe5a3' where color='#0a404b';"
echo "UPDATE filterinfo set color='#fd4207',bgcolor='#ffe8bd' where color='orange';"
echo "UPDATE filterinfo set color='blue' where code=4 or code=5;"
echo "UPDATE filterinfo set bgcolor='#a1d0f8' where color='blue';"
echo "UPDATE filterinfo set bgcolor='#bfbbbb' where color='black';"
echo "UPDATE filterinfo set bgcolor='#95b795' where color='green';"
echo "UPDATE filterinfo set bgcolor='#fb9090' where color='red';"
echo "UPDATE filterinfo set bgcolor='#ffffc9' where color='yellow';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-88
#adding orgdom to inqueue table
#---------------------------------------------------------------
upto_25088()

{
echo "Upgrading data-base to version $VERS-88" >> $LOGFILE
#Updating data-base structure
(
echo "ALTER TABLE inqueue ADD orgdom text;"
echo "GRANT SELECT,UPDATE ON inqueue TO apache;"
echo "UPDATE inqueue SET orgdom='';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-90
#changin status table and color
#---------------------------------------------------------------
upto_25090()

{
echo "Upgrading data-base to version $VERS-90" >> $LOGFILE
(
echo "ALTER TABLE users ADD dynamickey TEXT DEFAULT NULL;"
echo "CREATE INDEX emlogs_status ON emlogs (status);"
echo "UPDATE filterinfo set code=16 where code=15;"
echo "UPDATE filterinfo set bgcolor='#3393E5' where code=13;"
echo "COPY filterinfo (type, code, lang, color, str, description, bgcolor) FROM stdin;"
echo "1	15	1	#7F00FF	Delayed	Delayed delivery	#BE8EED"
echo "1	15	2	#7F00FF	Retard&eacute;	Livraison retard&eacute;	#BE8EED"
echo "\\."
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-94
#adding orgdom to inqueue table
#---------------------------------------------------------------
upto_25094()

{
echo "Upgrading data-base to version $VERS-94" >> $LOGFILE
#Updating data-base structure
(
echo "GRANT SELECT,INSERT,UPDATE ON clmgroup TO apache;"
echo "GRANT SELECT,UPDATE ON clmgroup_groupid_seq TO apache;"
echo "ALTER TABLE emlogs ADD grpin INTEGER;"
echo "ALTER TABLE emlogs ADD grpout INTEGER;"
echo "CREATE INDEX emlogs_grpin ON emlogs (grpin);"
echo "CREATE INDEX emlogs_grpout ON emlogs (grpout);"
echo "UPDATE emlogs SET grpin=1,grpout=0;"
echo "ALTER TABLE inqueue ADD grpin INTEGER;"
echo "CREATE INDEX queue_grpin ON inqueue (grpin);"
echo "UPDATE inqueue SET grpin=1;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-95
#removing listening on 127.0.0.1
#---------------------------------------------------------------
upto_25095()

{
echo "Upgrading data-base to version $VERS-95" >> $LOGFILE
#Updating data-base contente
(
echo "UPDATE binding SET active=0 WHERE binding='127.0.0.1';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-96
#updating spelling mistake
#---------------------------------------------------------------
upto_25096()

{
locdomain=`uname -na | cut -f 2- -d "." | cut -d " " -f 1`
echo "Upgrading data-base to version $VERS-96" >> $LOGFILE
#Updating data-base contente
(
echo "ALTER TABLE clmgroup ADD COLUMN clemserver TEXT;"
echo "UPDATE clmgroup SET clemserver='clement.$locdomain';"
echo "UPDATE filterinfo SET str='Exp&eacute;di&eacute' WHERE code=13 AND lang=2;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-98
#installing time zone in group
#---------------------------------------------------------------
upto_25098()

{
echo "Upgrading data-base to version $VERS-98" >> $LOGFILE
#Updating data-base contente
(
echo "ALTER TABLE clmgroup ADD COLUMN timezone TEXT;"
echo "UPDATE clmgroup SET timezone='EST5EDT';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-104
#installing new quarantine status
#---------------------------------------------------------------
upto_25104()

{
echo "Upgrading data-base to version $VERS-104" >> $LOGFILE
(
echo "UPDATE filterinfo set code=17 where code=16;"
echo "INSERT INTO filterinfo (type,code,lang,color,str,description,bgcolor)"
echo "		VALUES	(1,16,1,'#fd4207','Quarantine','To forward Mail set in quarantine','#FFDB99');"
echo "INSERT INTO filterinfo (type,code,lang,color,str,description,bgcolor)"
echo "		VALUES	(1,16,2,'#fd4207','Quarantaine','Courriel &agrave; retransmetre mis en quarantaine','#FFDB99');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-108
#installing new tobesend directory
#---------------------------------------------------------------
upto_25108()

{
(
echo "ALTER TABLE clmgroup ADD COLUMN quarantine TIMESTAMP WITH TIME ZONE;"
echo "UPDATE clmgroup set quarantine=(SELECT quarantine FROM info);"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON userprofile TO apache;"
echo "GRANT SELECT,UPDATE ON userprofile_prfid_seq TO apache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-109
#removing default lang from userprofile,domain and group
#---------------------------------------------------------------
upto_25109()

{
(
echo "UPDATE userprofile SET lang=NULL WHERE lang=1;"
echo "UPDATE clmgroup SET lang=NULL WHERE lang=1;"
echo "UPDATE domain SET lang=NULL WHERE lang=1;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-112
#removing blackholes.five-ten-sg.com from sbl list
upto_25112()
{
(
echo "DELETE FROM blshosts WHERE blsserver='blackholes.five-ten-sg.com';"
echo "ALTER TABLE inqueue ADD COLUMN numtrace INTEGER;"
echo "ALTER TABLE inqueue ALTER COLUMN numtrace SET DEFAULT 0;"
echo "UPDATE inqueue SET numtrace=0 WHERE numtrace IS NULL;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#procedure to upgrade to 2.5-114
#re-adding domain localhost.localdomain
upto_25115()
{
(
echo "UPDATE binding SET active=1,updated=NOW() WHERE binding='127.0.0.1';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-117
#add delete for table overrides
upto_25117()
{
(
echo "GRANT delete  ON overrides TO apache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-118
#inserting dynamickey within intuser table
upto_25118()
{
(
echo "ALTER TABLE intusers RENAME COLUMN stamp TO upto;"
echo "ALTER TABLE intusers ALTER COLUMN upto SET DEFAULT NOW()+'1 hour';"
echo "CREATE INDEX upto_ndx ON intusers (upto);"
echo "ALTER TABLE intusers ADD dynamickey TEXT DEFAULT NULL;"
echo "GRANT SELECT ON intusers TO apache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-120
#removing spamcannibal from list
upto_25120()
{
(
echo "DELETE FROM blshosts WHERE blsserver='bl.spamcannibal.org';"
echo "INSERT INTO blshosts (blsserver) VALUES('b.barracudacentral.org');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-121
#removing boxesize and adding table overuse.
upto_25121()
{
(
echo "ALTER TABLE userprofile DROP COLUMN boxsize;"
echo "CREATE TABLE overuse  ("
echo "username TEXT UNIQUE NOT NULL,"
echo "ratio FLOAT,"
echo "detected TIMESTAMP WITH TIME ZONE DEFAULT NOW()"
echo ");"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-122
#setting upto vriable to nul in users and domains
#---------------------------------------------------------------
upto_25122()
{
(
echo "UPDATE domain SET upto=NULL;"
echo "UPDATE users SET upto=NULL;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-125
#setting upto variable to nul in users and domains
#---------------------------------------------------------------
upto_25125()
{
(
echo "ALTER TABLE clmgroup ADD grace INTEGER DEFAULT 0 NOT NULL;"
echo "ALTER TABLE domain ADD grace INTEGER DEFAULT 0 NOT NULL;"
echo "ALTER TABLE domain ALTER COLUMN upto SET DEFAULT NULL;"
echo "ALTER TABLE users ALTER COLUMN upto SET DEFAULT NULL;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-129
#setting blshosts whith the ipmod field
#---------------------------------------------------------------
upto_25129()
{
(
echo "ALTER TABLE blshosts ADD ipmode TEXT DEFAULT 'ipv4' NOT NULL;"
echo "UPDATE blshosts SET ipmode='ipv4';"
echo "INSERT INTO blshosts (blsserver,ipmode) VALUES('ipv6.blacklist.woody.ch','ipv6');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-130
#adding record rejectto within inqueue table
#---------------------------------------------------------------
upto_25130()
{
(
echo "ALTER TABLE inqueue ADD rejectto TEXT DEFAULT '' NOT NULL;"
echo "UPDATE inqueue SET rejectto=orgeml;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-131
#setting default values for upto and quarantine within clmgroup
#---------------------------------------------------------------
upto_25131()
{
(
echo "ALTER TABLE clmgroup ALTER COLUMN upto SET DEFAULT NOW()+'1 year';"
echo "ALTER TABLE clmgroup ALTER COLUMN quarantine SET DEFAULT NOW()+'-2 day';"
echo "ALTER TABLE inqueue ADD orgstatus INTEGER DEFAULT 0;"
echo "UPDATE inqueue SET orgstatus=0;"
echo "UPDATE filterinfo SET code=18 WHERE code=17;"
echo "INSERT INTO filterinfo (type,code,lang,color,str,description,bgcolor)"
echo "		VALUES	(1,17,1,'green','Forwarded','Sent to remote server','#B8F6B8');"
echo "INSERT INTO filterinfo (type,code,lang,color,str,description,bgcolor)"
echo "		VALUES	(1,17,2,'green','Transmis','Transmis au serveur d&eacutesign&eacute;','#B8F6B8');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-133
#adding a filterinfo status (shouldn't be ever displayed)
#---------------------------------------------------------------
upto_25133()
{
(
echo "UPDATE filterinfo SET code=19 WHERE code=18;"
echo "INSERT INTO filterinfo (type,code,lang,color,str,description,bgcolor)"
echo "		VALUES	(1,18,1,'yellow','MustForward','Forced sent to remote server','#FFFFC9');"
echo "INSERT INTO filterinfo (type,code,lang,color,str,description,bgcolor)"
echo "		VALUES	(1,18,2,'yellow','ForceTransmis','Transmis obligatoirement au serveur d&eacute;sign&eacute;','#FFFFC9');"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-134
#adding a lastchk record to intuser table
#to check goog forward user only every day.
#---------------------------------------------------------------
upto_25134()
{
(
echo "ALTER TABLE intusers ADD COLUMN lastchk TIMESTAMP;"
echo "ALTER TABLE intusers ALTER COLUMN lastchk SET DEFAULT NOW();"
echo "UPDATE intusers SET lastchk=NOW()+'-1 day';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-134.5
#adding an new index on emltrt table first field.
#---------------------------------------------------------------
upto_25134005()
{
(
echo "CREATE INDEX  emltrt_first_ndx on emltrt(first);"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-135-1
#creating table ADMINLOGS
#---------------------------------------------------------------
upto_25135001()
{
(
echo "CREATE TABLE ADMINLOGS  ("
echo "user_dom TEXT,"
echo "admin TEXT,"
echo "datecomm TIMESTAMP WITH TIME ZONE DEFAULT NOW(),"
echo "type_log INTEGER,"
echo "message TEXT,"
echo "groupid INTEGER,"
echo "domain TEXT"
echo ");"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON adminlogs TO apache;"
echo "CREATE INDEX logs_domain ON adminlogs (domain);"
echo "CREATE INDEX logs_groupid ON adminlogs (groupid);"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-135-10
#creating table ADMINLOGS
#---------------------------------------------------------------
upto_25135010()
{
(
echo "REVOKE DELETE ON adminlogs FROM apache;"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON clmgroup TO apache;"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON domain TO apache;"
echo "GRANT SELECT,INSERT,UPDATE,DELETE ON users TO apache;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-136-13
#adding index to table emlogs.
#---------------------------------------------------------------
upto_25136013()

{
(
echo "CREATE INDEX emlogs_rmtip ON emlogs(rmtip);"
echo "CREATE INDEX emlogs_rmthost ON emlogs(rmthostname);"
echo "CREATE INDEX emlogs_rmtsubj ON emlogs(subject);"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-138-1
#creating table ADMINLOGS
#---------------------------------------------------------------
upto_25138001()
{
(
echo "UPDATE filterinfo set bgcolor='#95B795' where code=18;"
echo "ALTER TABLE overrides ADD COLUMN auser TEXT;"
echo "ALTER TABLE emlogs ADD COLUMN taille_num INTEGER;"
echo "UPDATE emlogs set taille_num=taille::int;"
echo "ALTER TABLE emlogs rename taille to taille_bad;"
echo "ALTER TABLE emlogs rename taille_num to taille;"
echo "CREATE INDEX emlogs_taille ON emlogs (taille);"
echo "ALTER TABLE emlogs DROP COLUMN taille_bad;"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#===============================================================
#procedure to upgrade to 2.5-138-12
#adding field within clmgroup table
upto_25138012()
{
(
echo "ALTER TABLE clmgroup ADD COLUMN authserver TEXT;"
echo "ALTER TABLE clmgroup ALTER COLUMN authserver SET DEFAULT NULL;"
echo "ALTER TABLE clmgroup ADD COLUMN authport TEXT;"
echo "ALTER TABLE clmgroup ALTER COLUMN authport SET DEFAULT '110';"
echo "ALTER TABLE clmgroup ADD COLUMN authproto TEXT;"
echo "ALTER TABLE clmgroup ALTER COLUMN authproto SET DEFAULT 'POP-3';"
echo "UPDATE clmgroup SET authport='110',authproto='POP-3';"
) | tee -a $LOGFILE | $SQL $DB_NAME
}
#---------------------------------------------------------------
#---------------------------------------------------------------
#Main process
#---------------------------------------------------------------
(
echo "#-------------------------------------------"
echo "#On" `date`
echo "#version upgrade from $OLDVERS to $CURVERS"
if [ $PRVRELNUM -lt 25000 ] ; then
  from_210xxx
  fi
if [ $PRVRELNUM -lt 25061 ] ; then
  upto_25060
  fi
if [ $PRVRELNUM -lt 25062 ] ; then
  upto_25062
  fi
if [ $PRVRELNUM -lt 25065 ] ; then
  upto_25065
  fi
if [ $PRVRELNUM -lt 25068 ] ; then
  upto_25068
  fi
if [ $PRVRELNUM -lt 25070 ] ; then
  upto_25070
  fi
if [ $PRVRELNUM -lt 25072 ] ; then
  upto_25072
  fi
if [ $PRVRELNUM -lt 25074 ] ; then
  upto_25074
  fi
if [ $PRVRELNUM -lt 25082 ] ; then
  upto_25082
  fi
if [ $PRVRELNUM -lt 25088 ] ; then
  upto_25088
  fi
if [ $PRVRELNUM -lt 25090 ] ; then
  upto_25090
  fi
if [ $PRVRELNUM -lt 25094 ] ; then
  upto_25094
  fi
if [ $PRVRELNUM -lt 25095 ] ; then
  upto_25095
  fi
if [ $PRVRELNUM -lt 25096 ] ; then
  upto_25096
  fi
if [ $PRVRELNUM -lt 25098 ] ; then
  upto_25098
  fi
if [ $PRVRELNUM -lt 25104 ] ; then
  upto_25104
  fi
if [ $PRVRELNUM -lt 25108 ] ; then
  upto_25108
  fi
if [ $PRVRELNUM -lt 25109 ] ; then
  upto_25109
  fi
if [ $PRVRELNUM -lt 25112 ] ; then
  upto_25112
  fi
if [ $PRVRELNUM -lt 25115 ] ; then
  upto_25115
  fi
if [ $PRVRELNUM -lt 25117 ] ; then
  upto_25117
  fi
if [ $PRVRELNUM -lt 25118 ] ; then
  upto_25118
  fi
if [ $PRVRELNUM -lt 25120 ] ; then
  upto_25120
  fi
if [ $PRVRELNUM -lt 25121 ] ; then
  upto_25121
  fi
if [ $PRVRELNUM -lt 25122 ] ; then
  upto_25122
  fi
if [ $PRVRELNUM -lt 25125 ] ; then
  upto_25125
  fi
if [ $PRVRELNUM -lt 25129 ] ; then
  upto_25129
  fi
if [ $PRVRELNUM -lt 25130 ] ; then
  upto_25130
  fi
if [ $PRVRELNUM -lt 25131 ] ; then
  upto_25131
  fi
if [ $PRVRELNUM -lt 25133 ] ; then
  upto_25133
  fi
if [ $PRVRELNUM -lt 25134 ] ; then
  upto_25134
  fi
if [ $PRVRELNUM -lt 25134005 ] ; then
  upto_25134005
  fi
if [ $PRVRELNUM -lt 25135001 ] ; then
  upto_25135001
  fi
if [ $PRVRELNUM -lt 25135010 ] ; then
  upto_25135010
  fi
if [ $PRVRELNUM -lt 25136013 ] ; then
  upto_25136013
  fi
if [ $PRVRELNUM -lt 25138001 ] ; then
  upto_25138001
  fi
if [ $PRVRELNUM -lt 25138012 ] ; then
  upto_25138012
  fi
) >> $LOGFILE 2>&1
(
echo "#==========================================="
) >> $LOGFILE
